<template>
  <div>
    <AppWindow
        v-bind:show="show"
        title="Edit project's scales"
        cancelable
        @canceled="() => this.$emit('canceled')"
        width="300"
        @submitted="saveBtnClick"
        :disabled-submit="!validForm"
    >
      <br>
      <v-form v-model="validForm">
        <v-text-field
            label="Max simulation time"
            v-model="simTime"
            color="secondary"
            suffix="s"
            hint="eg: 5e-9"
            :rules="[isNumber, notNul, notEmpty]"
        ></v-text-field>
        <v-text-field
            label="Frame time scale"
            v-model="timeScale"
            color="secondary"
            suffix="s"
            hint="eg: 5e-9"
            :rules="[isNumber, notNul, notEmpty]"
        ></v-text-field>
        <v-text-field
            label="Grid scale"
            v-model="moveScale"
            color="secondary"
            suffix="m/pixel"
            hint="eg: 5e-9"
            :rules="[isNumber, notNul, notEmpty]"
        ></v-text-field>
      </v-form>
      <template v-slot:submit-text>
        Save
      </template>
    </AppWindow>
  </div>
</template>

<script>
import AppWindow from './../AppWindow/AppWindow'
import {AppContext} from '@Util'

export default {
  name: 'EditSim',
  components: {
    AppWindow,
  },
  props: {
    show: Boolean
  },
  data: () => ({
    simTime: '',
    timeScale: '',
    moveScale: '',
    isNumber: val => !isNaN(Number(val)) || `${val} is not a valid number`,
    notNul: val => val !== '0' || 'Must be different from 0',
    notEmpty: val => val !== '' || `Can't be empty`,
    validForm: false,
  }),
  watch: {
    show(val) {
      if (val) {
        this.simTime = AppContext.currentProject.time
        this.timeScale = AppContext.currentProject.time_scale
        this.moveScale = AppContext.currentProject.scale
      }
      Object.assign(AppContext, {mode: val ? 0 : 2})
    }
  },
  methods: {
    saveBtnClick() {
      AppContext.currentProject.time = Number(this.simTime)
      AppContext.currentProject.time_scale = Number(this.timeScale)
      AppContext.currentProject.scale = Number(this.moveScale)
      AppContext.currentProject.RefreshElemPos()
      AppContext.currentProject.resetSim()
      AppContext.currentProject.Save()
      this.$emit('saved')
    }
  }
}
</script>